package eu.ztsh.wymiana.model;

import eu.ztsh.wymiana.web.model.UserCreateRequest;

import java.math.BigDecimal;

public class UserCreateRequestConfiguredWrapper {

    private final UserCreateRequest request;
    private final Symbol initialSymbol;

    public String name() {
        return request.name();
    }

    public String surname() {
        return request.surname();
    }

    public String pesel() {
        return request.pesel();
    }

    public BigDecimal initial() {
        return request.initial();
    }

    public Symbol initialSymbol() {
        return initialSymbol;
    }

    private UserCreateRequestConfiguredWrapper(Builder builder) {
        this.request = builder.request;
        this.initialSymbol = builder.initial;
    }

    public static Builder wrap(UserCreateRequest request) {
        return new Builder().withRequest(request);
    }

    public static final class Builder {

        private UserCreateRequest request;
        private Symbol initial;

        private Builder() {
        }

        private Builder withRequest(UserCreateRequest request) {
            this.request = request;
            return this;
        }

        public Builder withInitial(Symbol initial) {
            this.initial = initial;
            return this;
        }

        public UserCreateRequestConfiguredWrapper build() {
            return new UserCreateRequestConfiguredWrapper(this);
        }

    }

}
