package eu.ztsh.wymiana.validation;

import jakarta.validation.Constraint;
import jakarta.validation.Payload;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.TYPE_USE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;


@Retention(RUNTIME)
@Target({ TYPE_USE })
@Documented
@Constraint(validatedBy = {ValidExchangeRequestValidator.class })
public @interface ValidExchangeRequest {

    String message() default "Exchange request is not valid";
    Class<?>[] groups() default { };
    Class<? extends Payload>[] payload() default { };

}
