package eu.ztsh.wymiana;

import eu.ztsh.wymiana.data.entity.UserEntity;
import eu.ztsh.wymiana.data.repository.UserRepository;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import static org.assertj.core.api.Assertions.assertThat;

@SpringBootTest
@ExtendWith(SpringExtension.class)
public abstract class RepositoryBasedTest {

    protected final UserRepository userRepository;

    public RepositoryBasedTest(UserRepository userRepository) {
        this.userRepository = userRepository;
    }

    @BeforeEach
    void prepareTest() {
        userRepository.deleteAll();
    }

    public void expect(UserEntity entity) {
        assertThat(userRepository.findById(entity.getPesel()))
            .isNotEmpty()
            .get()
            .usingRecursiveComparison()
            .ignoringCollectionOrder()
            .isEqualTo(entity);
    }

}
